<?php
/**************************** version 20180716 ****************************/
############################################################################
$viewSource = false;
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
//--self downloader --
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   readfile($filenameReal);
   exit;
}
############################################################################
?>
<div id="showForecast" align="center">
<?php
if (!isset($_POST['divWidth'])&&!isset($mapType)) {
	$_SESSION['CSSwidescreen'] = true;
	$useOnClick = false; // Use onclick instead of onmouseover to display a chart
	$divWidth = 900; // Initial widescreen map width.  Varies depending upon map type
	$narrowWidth = 656; // Initial Narrow map width - set in wxna24hsa.php
	$standAlone = true; // Initial value
	$aspect = .75; // Initial aspect ratio
	$mapType = 'satsfcnps'; //'radsfcus_exp_new','satsfcnps', 'satsfc', 'ussatsfc', 'Td', 'TdERR', or 'VIS'
	echo '<link href="css/hover.css" rel="stylesheet" media="all"/>
	<style type="text/css">
	.hidden {
		display: none;
		position:absolute;
	}
	.shown {
		display: block;
		position:absolute;
	}
	div.center {
		width:100%;
		margin-left: auto;
		margin-right: auto;
	}
	</style>
	<script src="//ajax.googleapis.com/ajax/libs/jquery/1.10.2/jquery.min.js" type="text/javascript"></script>'
	;
}
if (isset($_POST['maptype'])) {
	$mapType = $_POST['maptype'];
	if ($_SERVER["REMOTE_ADDR"]=='127.0.0.1') {
	  include ('Settings.php'); // AJAX forgets these on localhost!
	}
}
if (isset($_POST['useOnClick'])) { # Are we using AJAX???
	$useOnClick = $_POST['useOnClick']; # If so, set maptype, mouse behavior, and div width.
	if ($_SERVER["REMOTE_ADDR"]=='127.0.0.1') {
	  include ('Settings.php'); // AJAX forgets these on localhost!
	}
}
if (isset($_POST['divWidth'])) { # Are we using AJAX???
	$divWidth = $_POST['divWidth']; # If so, set fctype.
	if ($_SERVER["REMOTE_ADDR"]=='127.0.0.1') {
	  include ('Settings.php'); // AJAX forgets these on localhost!
	}
}
if (isset($_POST['narrowWidth'])) { # Are we using AJAX???
	$narrowWidth = $_POST['narrowWidth']; # If so, set fctype.
	if ($_SERVER["REMOTE_ADDR"]=='127.0.0.1') {
	  include ('Settings.php'); // AJAX forgets these on localhost!
	}
}
if (isset($_POST['standAlone'])) { # Are we using AJAX???
	$standAlone = $_POST['standAlone']; # If so, set fctype.
	if ($_SERVER["REMOTE_ADDR"]=='127.0.0.1') {
	  include ('Settings.php'); // AJAX forgets these on localhost!
	}
}
date_default_timezone_set("GMT");	# The NWS calculations for these charts is GMT, and AJAX forgets it!
$timeNow = timenow_adjust();
#echo '$timeNow = '.$timeNow.'<br/>'; // Debug Code
$hours8 = array();
for ($i=0; $i<8; $i++) { // Populate Array
	$hours8[$i] = $i*3;
	if ($hours8[$i]<10) { // Adjust for missing zeros
		$hours8[$i] = '0'.$hours8[$i];
	}
}
$j = 7-floor($timeNow/3);
for ($i=0; $i<$j; $i++) {
	if ($hours8[$i] > $timeNow) {
		break;
	}
	$junk = array_pop($hours8);
	array_unshift($hours8,$junk);
}
/*
echo '$i = '.$i.', $j = '.$j.', $hours8['.$i.'] = '.$hours8[$i].'<br/>'; // Debug Code
for ($i=0; $i<8; $i++) { // Debug Code
	echo 'post-$hours8['.$i.'] = '.$hours8[$i].'<br/>'; // Debug Code
} // Debug Code
*/
function timenow_adjust() {
	$theHour = (date("H"));
#	$theHour = 22; // Debug Code
	$mapHour = $theHour-($theHour%3); // Need multiple of 3 for $mapHour
	if (($mapHour == 0) && ($theHour<2)) { // New maps not up yet and
		$theTime = 21;											 // and old maps begin yesterday
#		echo 'Option $mapHour == 0) && ($theHour<2)<br/>'; // Debug Code
		return $theTime;
	} else if (($theHour%3)<=1){ // New maps not up yet so use old maps
		$theTime = (($mapHour>=3)?($mapHour-3):'21'); // which may begin yesterday
#		echo 'Option ($theHour%3)<=1<br/>'; // Debug Code
		return ($theTime<9)?'0'.$theTime:$theTime;
	} else { // Defaults to here (($theHour%3)==2) where new maps are up
		$theTime = $mapHour; // at 2 hrs past 00~02,03~05,06~08,09~11, etc.
#		echo 'Option ($theHour%3)==2<br/>'; // Debug Code
		return ($theTime<9)?'0'.$theTime:$theTime;
	}
}

$wbg = false; // White Background Map?
if ($mapType == 'satsfc') {
	$mapText = 'Sat. Overlay N. America - Pacific';
	$wideWidth = 900;
	$aspect = .75;
} else if ($mapType == 'satsfcnps') {
	$mapText = 'Sat. Overlay North America';
	$wideWidth = 900;
	$aspect = .75;
} else if ($mapType == 'ussatsfc') {
	$mapText = 'Sat. Overlay Continental US';
	$wideWidth = 900;
	$aspect = .75;
} else if ($mapType == 'radsfcus_exp_new') {
	$mapText = 'Radar Overlay Continental US';
	$wideWidth = 675;
	$aspect = .7;	
} else if ($mapType == 'bwsfc') {
	$mapText = 'Continental US';
	$wideWidth = 750;
	$aspect = .75;	
} else if ($mapType == 'usdwmsfc') {
	$mapText = 'Surface &amp; Station Weather';
	$wideWidth = 1088;
	$aspect = .72;
	$wbg = true;	
} else if ($mapType == 'namsfc') {
	$mapText = 'Aviation Style North America';
	$wideWidth = 750;
	$aspect = .75;
	$wbg = true;
} else if ($mapType == 'lrgnamsfc') {
	$mapText = 'Aviation Style North America Clickable';
	$wideWidth = 900;
	$aspect = .75;
	$wbg = true;
} else if ($mapType == 'namussfc') {
	$mapText = 'Aviation Style US';
	$wideWidth = 750;
	$aspect = .75;
	$wbg = true;	
} else if ($mapType == 'usfntsfc') {
	$mapText = 'Fronts Only US';
	$wideWidth = 750;
	$aspect = .75;
	$wbg = true;	
} else if ($mapType == 'namnesfc') {
	$mapText = 'Aviation Style North East US';
	$wideWidth = 750;
	$aspect = .75;
	$wbg = true;	
} else if ($mapType == 'namcesfc') {
	$mapText = 'Aviation Style Central East US';
	$wideWidth = 750;
	$aspect = .75;
	$wbg = true;	
} else if ($mapType == 'namsesfc') {
	$mapText = 'Aviation Style South East US';
	$wideWidth = 750;
	$aspect = .75;
	$wbg = true;	
} else if ($mapType == 'namncsfc') {
	$mapText = 'Aviation Style North Central US';
	$wideWidth = 750;
	$aspect = .75;
	$wbg = true;	
} else if ($mapType == 'namccsfc') {
	$mapText = 'Aviation Style Mid-Central US';
	$wideWidth = 750;
	$aspect = .75;
	$wbg = true;	
} else if ($mapType == 'namscsfc') {
	$mapText = 'Aviation Style South Central US';
	$wideWidth = 750;
	$aspect = .75;
	$wbg = true;	
} else if ($mapType == 'namnwsfc') {
	$mapText = 'Aviation Style North West US';
	$wideWidth = 750;
	$aspect = .75;
	$wbg = true;	
} else if ($mapType == 'namcwsfc') {
	$mapText = 'Aviation Style Central West US';
	$wideWidth = 750;
	$aspect = .75;
	$wbg = true;	
} else if ($mapType == 'namswsfc') {
	$mapText = 'Aviation Style South West US';
	$wideWidth = 750;
	$aspect = .75;
	$wbg = true;	
} else if ($mapType == 'namaksfc') {
	$mapText = 'Aviation Style Alaska';
	$wideWidth = 750;
	$aspect = .75;
	$wbg = true;	
} else if ($mapType == 'namak2sfc') {
	$mapText = 'Aviation Style Alaskan Gulf';
	$wideWidth = 750;
	$aspect = .75;
	$wbg = true;	
}
#$divWidth = ($_SESSION['CSSwidescreen']==1 ? $wideWidth : $divWidth);
$theHour = date("H");
#$theHour = '22'; // Debug Code
?>
<div style="width:<?php echo $divWidth?>px">
<span style="color:#000000; font-size:13px; font-family:arial, times new roman; font-size:large">
<b>Select Map Type and Region:</b> &nbsp;
</span>

<select style="border:1px solid #000000; background-color:#FFFFFF; font-size:12px;" name="maptype">

<optgroup label="Satellite Overlay">
  <option value="satsfc"<?php echo (($mapType=='satsfc')?' selected="selected"':'');?>>N. America/Pacific</option>
  <option value="satsfcnps"<?php echo (($mapType=='satsfcnps')?' selected="selected"':'');?>>North America</option>
  <option value="ussatsfc"<?php echo (($mapType=='ussatsfc')?' selected="selected"':'');?>>Continental US</option>
</optgroup>

<optgroup label="Radar Overlay">
  <option value="radsfcus_exp_new"<?php echo (($mapType=='radsfcus_exp_new')?' selected="selected"':'');?>>Continental US</option>
</optgroup>

<optgroup label="Color Analysis">
  <option value="bwsfc"<?php echo (($mapType=='bwsfc')?' selected="selected"':'');?>>US and Canada</option>
  <option value="usdwmsfc"<?php echo (($mapType=='usdwmsfc')?' selected="selected"':'');?>>Surface &amp; Station Weather</option>
</optgroup>

<optgroup label="Aviation Style">
  <option value="namsfc"<?php echo (($mapType=='namsfc')?' selected="selected"':'');?>>North America</option>
  <option value="lrgnamsfc"<?php echo (($mapType=='lrgnamsfc')?' selected="selected"':'');?>>Larger NA Clickable</option>
  <option value="namussfc"<?php echo (($mapType=='namussfc')?' selected="selected"':'');?>>US</option>
  <option value="usfntsfc"<?php echo (($mapType=='usfntsfc')?' selected="selected"':'');?>>US Fronts Only</option>
  <option value="namnesfc"<?php echo (($mapType=='namnesfc')?' selected="selected"':'');?>>North East US</option>
  <option value="namcesfc"<?php echo (($mapType=='namcesfc')?' selected="selected"':'');?>>Central East US</option>
  <option value="namsesfc"<?php echo (($mapType=='namsesfc')?' selected="selected"':'');?>>South East US</option>
  <option value="namncsfc"<?php echo (($mapType=='namncsfc')?' selected="selected"':'');?>>North Central US</option>
  <option value="namccsfc"<?php echo (($mapType=='namccsfc')?' selected="selected"':'');?>>Mid-Central US</option>
  <option value="namscsfc"<?php echo (($mapType=='namscsfc')?' selected="selected"':'');?>>South Central US</option>
  <option value="namnwsfc"<?php echo (($mapType=='namnwsfc')?' selected="selected"':'');?>>North West US</option>
  <option value="namcwsfc"<?php echo (($mapType=='namcwsfc')?' selected="selected"':'');?>>Central West US</option>
  <option value="namswsfc"<?php echo (($mapType=='namswsfc')?' selected="selected"':'');?>>South West US</option>
  <option value="namaksfc"<?php echo (($mapType=='namaksfc')?' selected="selected"':'');?>>Alaska</option>
  <option value="namak2sfc"<?php echo (($mapType=='namak2sfc')?' selected="selected"':'');?>>Alaskan Gulf</option>
</optgroup>

</select>

<script type="text/javascript">
  var $jq = jQuery.noConflict();
  $jq("select").change(function () {
    var maptype = $jq(this).val();
    showForecastjs(maptype,<?php echo $divWidth?>,<?php echo $useOnClick?1:0?>,<?php echo $narrowWidth?>,<?php echo $standAlone?1:0?>);
  });
</script>


  <h2 align="center">NWS Weather Prediction Center Surface Analysis Charts:<br/><?php echo 'Past 24 Hour '.$mapText; ?></h2>
    <div class="center" style="text-align:center; width:<?php echo $divWidth?>px">
    
	<?php echo '<span style="line-height:140%">Note: Times are UTC (Zulu, currently <b><span id="zTimer">'.gmdate("Hi").'</span>Z)</b></span><br/>';?>

      <?php
			$newDay = array();
			$rowWidth = $divWidth>$narrowWidth?'90':'70';
      ?>
      <table width="99%" align="center">
        <tr style="font-weight:bold; padding: 0px; vertical-align:top" align="center" >
      <?php

			for ($k=0; $k<8; $k++) {
			  if ($k==0) { // Add Month and Day to Start of Thumbnails
					if ($hours8[$k] == '00') {
				  	echo '<td>'.(($theHour<2)?(date("M j",mktime($theHour,0,0,date("n"),date("j")-1))):(date("M j",mktime($theHour)))).':&nbsp;</b> ';
					}	else {
						echo '<td>'.date("M j",mktime($theHour,0,0,date("n"),date("j")-1)).':&nbsp;</td> ';
					}
			  }
				 else if ($hours8[$k]<21) {
					if ($hours8[$k]=='00') {
						echo '<td>'.date("M j",mktime(date("H"),0,0,date("n"),date("j"))).':&nbsp;</td> ';
					}
				} // Now add thumbnail links
		    echo '<td>'.$hours8[$k].'00Z<br/><a class="hvr-glow hvr-grow" style="cursor:pointer" on'.($useOnClick?'click':'mouseover').'="show_tab(\'hour'.$hours8[$k].'\')"><img src="https://www.wpc.ncep.noaa.gov/sfc/'.$mapType.$hours8[$j].($wbg?'wbg':'').'.gif" width="'.$rowWidth.'" alt=""/></a></td>';
			}
		?>
    </tr></table>
    <span style="font-size:10px; line-height:130%">(<?php echo ($useOnClick?'Click':'Hover Over')?> a Thumbnail to Display Map)</span>
    <hr/></div>
    <br/>
    </div>		
		<div class="center" style="width:<?php echo $divWidth ?>px">
    <br/>
    <?php  
		  for ($j=0; $j<8; $j++) { // Display Maps and create javascript mouseover/click id's
        echo (($divWidth<$wideWidth)?'<a href="https://www.wpc.ncep.noaa.gov/sfc/'.$mapType.$hours8[$j].($wbg?'wbg':'').'.gif" target="_blank" title="Larger Image">':'').'<img src="https://www.wpc.ncep.noaa.gov/sfc/'.$mapType.$hours8[$j].($wbg?'wbg':'').'.gif" id="hour'.$hours8[$j].'" class="center hidden" style="width:'.$divWidth.'px; height:'.($divWidth*$aspect).'px" alt="Hour '.$hours8[$j].'"/>'.(($divWidth<$wideWidth)?'</a>':'');
		  }
		 ?>
	  <div class="center" style="width:<?php echo $divWidth ?>px; display:block"> <!-- Set up default map -->
        <?php echo ($divWidth<$wideWidth?'<a href="https://www.wpc.ncep.noaa.gov/sfc/'.$mapType.$hours8[0].($wbg?'wbg':'').'.gif" target="_blank" title="Larger Image">':'').'<img class="center" src="https://www.wpc.ncep.noaa.gov/sfc/'.$mapType.$hours8[0].($wbg?'wbg':'').'.gif" style="width:'.$divWidth.'px; height:'.($divWidth*$aspect).'px;" alt="Hour '.$hours8[0].'"/>'.(($divWidth<$wideWidth)?'</a>':'');?>
    </div>
    </div>
    <div class="center" style="width:<?php echo $divWidth ?>px; text-align:center">
    	<span style="line-height:110%"><br/><b>These maps are updated about 2 hours after their indicated analysis time.</b></span><br/>
      <span style="font-size:11px; line-height:120%">(The next updates will be the <?php echo ($hours8[0].'00Z');?> maps at about <?php echo ((($hours8[0]+2)<10)?'0'.($hours8[0]+2):$hours8[0]+2).'00Z'?> when this page will refresh automatically.)</span><br/><br/>
      <span style="line-height:130%; font-size:14px; font-weight:bold"><a href="wxna24hsaloops<?php echo $standAlone?'-SA':''?>.php">Looped Images</a><br/>
     <?php echo $divWidth==$narrowWidth?'<a href="wxna24hsa-SA.php" target="_blank" title="Largest Maps in New Tab">Full Size Maps</a>':''?>
     </span><br/><hr/>
   <span style="font-size:10px;line-height:130%">Maps and Data Courtesy of NOAA NWS <a href="https://www.wpc.ncep.noaa.gov/index.shtml" target="_blank" title="Opens in New Tab">Weather Prediction Center</a> <a href="https://www.wpc.ncep.noaa.gov/html/sfc2.shtml" target="_blank" title="Opens in New Tab">North American Surface Analysis</a>.<br/>Script by <a href="https://www.gwwilkins.org" target="_blank" title="Opens in New Tab">SE Lincoln Weather</a>.</span><br/>
</div>
</div>
<script language="Javascript" type="text/javascript">
function show_tab(nam)
{
  <?php // Set up 24 hr. every 3 hour map array to display selected map
  for ($i=0; $i<8; $i++) {
    echo '  document.getElementById("hour'.(($i*3<10)?('0'.$i*3):$i*3).'").style.display="none";'."\n";
  }
  ?> 
  document.getElementById(nam).style.display = "block";
}
</script>
<script type="text/javascript">
function redoPage() {
    var $jq = jQuery.noConflict();
		zuluTimer(); // Need to restart our timer from scratch!
    showForecastjs("<?php echo $mapType?>",<?php echo $divWidth?>,<?php echo $useOnClick?1:0?>);
  };
</script>
<script type="text/javascript">
function zuluTimer() {<!--
//<![CDATA[
  var d = new Date();
  var _min = d.getMinutes();
	var _hour = d.getUTCHours();
	var _sec = d.getSeconds();
//	if (!(_sec%60)) { redoPage(); } // Refresh page to catch latest maps - Debug Code
  if ( ( ((_hour+1)/3)== Math.round((_hour+1)/3) )&&(!(_min%60)&&!(_sec%60))) { // Awaken things before redoing page
    console.log("((_hour+1)/3): "+((_hour+1)/3)); 
	  console.log("Math.round((_hour+1)/3): "+Math.round((_hour+1)/3));
  }
	if ((((_hour+1)/3)== Math.round((_hour+1)/3))&&!(_min%60)&&!(_sec%60)) { redoPage(); } // Refresh page to catch latest maps
  var count = (60 - _sec); // current count
  var counter=setInterval(timer, 1000);
  function timer() {
    count=count-1;
    if (count <= 0) {
      clearInterval(counter);
      zuluTimer();
    }
  } document.getElementById("zTimer").innerHTML = ((_hour<10)?('0'+_hour):_hour).toString() + ((_min<10)?('0'+_min):_min).toString();
	  // Place .getElementById here to refresh every minute (currently specified interval)
} zuluTimer();
//]]>
-->
</script>
